=== debian/changelog ===
sundials (2.7.0+dfsg-2build1) bionic; urgency=medium

  * Rebuild against new hypre 2.13.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 12 Dec 2017 12:17:13 +0100

sundials (2.7.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Look for KLU library into the right multiarch directory.
    Fixes FTBFS on any-i386.
  * Bump Standards-Version to 4.1.0.

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 28 Aug 2017 18:22:01 +0200

sundials (2.7.0+dfsg-1) experimental; urgency=medium

  * Team upload.

  [ Dima Kogan ]
  * New upstream release (Closes: #798331, #809072)
    - Upstream dropped octave support, so the "octave-sundials" package is
      gone
  * Package reorganized: all documentation, dev files into new
    "libsundials-dev" package
  * All examples are shipped and are buildable and runnable in "libsundials-dev"
  * All parallelization options shipped in the various packages:
    - libsundials-nvecparallel-hypre2
    - libsundials-nvecparallel-mpi2
    - libsundials-nvecparallel-openmp2
    - libsundials-nvecparallel-petsc2
    - libsundials-nvecparallel-pthread2
  * Package repo moved to git

  [ Andreas Tille ]
  * Build hardening=+bindnow
  * Set Dima Kogan and James Tocknell as Uploaders
  * Reorganized debian/copyright: it now conforms to the dep5 standard
  * Updated to debhelper 10
  * Fixed watch file: it works now
  * Fix Vcs fields

  [ James Tocknell ]
  * Improve PETSc support
  * Update BLAS/LAPACK deps to correct metapackages

  [ Sylvestre Ledru ]
  * Removed Sylvestre Ledru from the uploaders

  [ Sébastien Villemot ]
  * Bump Standards-Version to 4.0.1.

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 18 Aug 2017 11:44:19 +0200

sundials (2.5.0-3) unstable; urgency=low

  * Team upload.
  * Revert changes from experimental version which inadvertently made it into
    the previous upload.
  * Improve the fix for missing BLAS and LAPACK dependencies (closes: #700525)
    + no longer pass BLAS and LAPACK through LDFLAGS
    + link-blas-lapack.patch: new patch which rather adds the dependencies at
      the libtool link level
    + add missing dependency of libsundials-serial-dev on libblas-dev and
      liblapack-dev
  * Fix the dependency of octave-sundials on octave.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 27 Feb 2013 16:58:32 +0100

sundials (2.5.0-2) unstable; urgency=low

  * debian/rules:
      - Add -lblas -llapack -lm to LDFLAGS (closes: #700525)

 -- Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>  Thu, 14 Feb 2013 16:58:48 +0100

sundials (2.5.0-2~exp1) experimental; urgency=low

  [ Andrew Miller ]
  * Fix spelling of suite (closes: #680881)
  * Add a -dbg package (closes: #680878)

  [ Rafael Laboissiere ]
  * debian/rules:
      - Install .mex files in the appropriate directory

  * Switch to buildsystem to cmake
  * Switch to debhelper 9
  * Switch to dpkg-source 3.0 (quilt) format

  * Add support for parallel version
  * Add a separate package for examples
  * Modify check.sh to run serial tests

 -- Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>  Mon, 9 Jul 2012 09:40:03 +1200

sundials (2.5.0-1) unstable; urgency=low

  * New upstream release
  * Remove sh4.patch
  * Standards-Version changed to 3.9.3

  [Kamaraju Kusumanchi][Rafael Laboissiere]
  * Adjust for the new octave package version 3.6.1 (closes: #668830)

 -- Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>  Tue, 24 Apr 2012 08:49:39 +0200

sundials (2.4.0-6) unstable; urgency=low

  * Rebuild using the last version of hdf5.

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 26 Jan 2012 10:18:07 +0100

sundials (2.4.0-5) unstable; urgency=low

  * debian/rules: remove duplicate definition of debexp var.
    This brings back the missing static libraries (closes: #650933)
  * debian/control: add DM-Upload-Allowed

 -- Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>  Mon, 05 Dec 2011 08:36:33 +0100

sundials (2.4.0-4) unstable; urgency=low

  * add octave support
  
  [Peter Green]
  * debian/patches: add fix-format-error.patch (Closes: #646457)

 -- Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>  Mon, 24 Oct 2011 15:01:41 +0200

sundials (2.4.0-3) unstable; urgency=low

  * Change the uploader to Debian Science
  * Standards-Version changed to 3.9.2

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 08 Aug 2011 22:29:34 +0200

sundials (2.4.0-2) unstable; urgency=low

  [Nobuhiro Iwamatsu]
  * debian/patches: add sh4.patch (Closes: #602160)

 -- Christophe Trophime <christophe.trophime@grenoble.cnrs.fr>  Mon, 14 Feb 2011 11:25:18 +0100

sundials (2.4.0-1) unstable; urgency=low

  * Standards-Version changed to 3.9.1

  [ Christophe Trophime ]
  * Team upload
  * New upstream version
  * Add a separate package for IDAS
  * Remove pdf from the orig tarball
  * debian/control:  add missing builddependencies on blas/lapack
  * debian/control: remove libsundials-serial-doc
  * debian/rules: modify get-orig-rules target to remove pdf from the orig
    tarball
  * debian/orig-tarball.sh: change to force download to tarballs directory
	
 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 09 Oct 2010 18:18:22 +0200

sundials (2.3.0-2) unstable; urgency=low

  * Package moved to debian-science
  * Raphael removed and add myself in the Uploaders list (Closes: #571898)
  * Missing replace/conflicts added (Closes: #540498)
  * No longer install *.la files
  * bashim removed (Closes: #530983)
  * Standards-Version updated to version 3.8.4

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 30 Mar 2010 22:54:48 +0200

sundials (2.3.0-1) unstable; urgency=low

  [ Andrey Romanenko ]
  * New upstream release
  * Added sundials-config man page

  [ Rafael Laboissiere ]
  * Switch from CDBS' simple-patchsys to quilt
  * Split the libsundials-serial package into individual library packages
  * debian/clean: Add file for removing config.log (Lintian warning) and the

